Last Comment Bug 629472 - Parts of windowless, transparent nspluginwrapper/Flash plugin not repainted correctly
: Parts of windowless, transparent nspluginwrapper/Flash plugin not repainted c...
Status: RESOLVED FIXED
: regression
Product: Core
Classification: Components
Component: Plug-ins (show other bugs)
: unspecified
: x86_64 Linux
: -- normal with 1 vote (vote)
: mozilla6
Assigned To: Karl Tomlinson (back Feb 1 :karlt)
:
: Benjamin Smedberg [:bsmedberg]
Mentors:
http://www.communitymx.com/content/so...
: 631232 648454 (view as bug list)
Depends on: 603397
Blocks: 556487 598112
  Show dependency treegraph
 
Reported: 2011-01-27 12:01 PST by Chris Jones [:cjones] inactive; ni?/f?/r? if you need me
Modified: 2011-05-08 17:17 PDT (History)
13 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
.x+


Attachments
screencast of the reproduction (840.08 KB, video/webm)
2011-04-14 08:40 PDT, Matěj Cepl
no flags Details
revert to using NP_GetValue (4.49 KB, patch)
2011-04-25 21:05 PDT, Karl Tomlinson (back Feb 1 :karlt)
no flags Details | Diff | Splinter Review
revert to using NP_GetValue 1.0.1 (4.54 KB, patch)
2011-04-25 22:30 PDT, Karl Tomlinson (back Feb 1 :karlt)
cjones.bugs: review+
Details | Diff | Splinter Review

Description User image Chris Jones [:cjones] inactive; ni?/f?/r? if you need me 2011-01-27 12:01:59 PST
STR
 (1) Load the URL

The little purple ball is painted by the flash instance.  On my gtk2 desktop, I only see the ball drawn when it's between the north and west points of the star.  It's supposed to be drawn all throughout the box, because the applet is at a higher z-index than the star image and background (if I read the source correctly).

3.6 works as expected.
Comment 1 User image Chris Jones [:cjones] inactive; ni?/f?/r? if you need me 2011-01-27 12:02:33 PST
Regression in rendering from 3.6.
Comment 2 User image Timothy Nikkel (:tnikkel) 2011-01-27 12:06:54 PST
Linux only or not?
Comment 3 User image Chris Jones [:cjones] inactive; ni?/f?/r? if you need me 2011-01-27 12:09:48 PST
Kevin reports this working correctly on windows in beta10.
Comment 5 User image Timothy Nikkel (:tnikkel) 2011-01-27 12:32:35 PST
Perhaps one of Oleg's changesets?
Comment 6 User image Karl Tomlinson (back Feb 1 :karlt) 2011-01-27 14:26:18 PST
Works fine here with "Shockwave Flash 10.3 d162".
cjones has 10.1 r102 and nspluginwrapper.
tn are you using nspluginwrapper?
Comment 7 User image Chris Jones [:cjones] inactive; ni?/f?/r? if you need me 2011-01-27 15:23:39 PST
FTR, with "10.3 d162" the problem goes away.  But, with the WIP patches in bug 626602 with "10.3 d162", the problem comes *back*.
Comment 8 User image Timothy Nikkel (:tnikkel) 2011-01-27 15:56:08 PST
(In reply to comment #6)
> tn are you using nspluginwrapper?

Yes, I _think_ so. Not sure how to check. I have the same version as cjones in comment 6 though.
Comment 9 User image Timothy Nikkel (:tnikkel) 2011-01-27 16:00:39 PST
about:plugins says
File: npwrapper.libflashplayer.so
Comment 10 User image Johnny Stenback (:jst, jst@mozilla.com) 2011-02-01 12:30:37 PST
Should be fixed, but this won't be a priority for 2.0.
Comment 11 User image Benjamin Smedberg [:bsmedberg] 2011-02-03 11:05:23 PST
*** Bug 631232 has been marked as a duplicate of this bug. ***
Comment 12 User image Chris Jones [:cjones] inactive; ni?/f?/r? if you need me 2011-02-03 13:13:19 PST
(In reply to comment #7)
> FTR, with "10.3 d162" the problem goes away.  But, with the WIP patches in bug
> 626602 with "10.3 d162", the problem comes *back*.

In case it helps, my patch had made it so that

     if (mIsTransparent && (GetQuirks() & PluginModuleChild::QUIRK_FLASH_EXPOSE_COORD_TRANSLATION)) {

in PluginInstanceChild stopped running, unintentionally.  Fixing that made the bug go away again.
Comment 13 User image Karl Tomlinson (back Feb 1 :karlt) 2011-02-03 13:27:25 PST
Thanks.

Does nspluginwrapper pass through the "Shockwave Flash 10.1 r102" in-tact?
i.e. is that what about:plugins says for "Version:"?
Comment 14 User image Timothy Nikkel (:tnikkel) 2011-02-03 14:02:04 PST
From my about:plugins, the complete flash section:

Shockwave Flash

    File: npwrapper.libflashplayer.so
    Version: 
    Shockwave Flash 10.1 r102

MIME Type 	Description 	Suffixes
application/x-shockwave-flash 	Shockwave Flash 	swf
application/futuresplash 	FutureSplash Player 	spl
Comment 15 User image Henri Sivonen (:hsivonen) 2011-02-03 23:47:15 PST
To answer karlt's IRC question about whether I can invoke the Flash Player context menu on http://www.qwiki.com/q/#!/Finland : Yes, the plug-in's context menu is invokable as usual.

http://www.communitymx.com/content/source/E5141/wmodetrans.htm shows me the same problem that is described in comment 0. In this case, the misclipping is constant. In the qwiki case, the misclipping varies as the swf plays.
Comment 16 User image Dave Miller [:justdave] (justdave@bugzilla.org) 2011-03-31 20:18:40 PDT
FWIW, I'm also seeing this, so if there's anything I can do to help debug, let me know.  In my case, I'm seeing things that feel like this same issue while trying to use embedded video players on Crunchyroll and Hulu.  The videos play fine, but the controls black out when you mouse over them.  Everything works fine in full-screen mode, it only blacks out when viewed embedded within the browser window.
Comment 17 User image Karl Tomlinson (back Feb 1 :karlt) 2011-04-07 21:56:57 PDT
*** Bug 648454 has been marked as a duplicate of this bug. ***
Comment 18 User image Timothy Nikkel (:tnikkel) 2011-04-11 15:08:32 PDT
Bug 648454 contains a description of what is likely the problem here.
Comment 19 User image Matěj Cepl 2011-04-14 08:40:46 PDT
Created attachment 526008 [details]
screencast of the reproduction

Just a good reproducer of the issue I see on http://jsbin.tumblr.com/post/4605622638/a-demo-of-the-simple-drag-and-drop-functionality
Comment 20 User image Karl Tomlinson (back Feb 1 :karlt) 2011-04-25 18:56:23 PDT
Based on Bug 603397 comment 13 and bug 648454, it sounds like this is caused
by the switch from using NP_GetValue to NPPluginFuncs::getvalue for the Flash
NPPVpluginDescriptionString test.
http://hg.mozilla.org/mozilla-central/rev/6bf95d58032e

This was fortunate enough to work fine with Flash Player directly (apparently
because Flash handles both methods the same), but what really confuses
nspluginwrapper is that NPPluginFuncs::getvalue is called (incorrectly) before
newp has been called to construct the instance.
Comment 21 User image Karl Tomlinson (back Feb 1 :karlt) 2011-04-25 21:05:29 PDT
Created attachment 528261 [details] [diff] [review]
revert to using NP_GetValue

Can you check that this fixes the issue, please Timothy?

GetPluginInfo does more work than necessary but I think it is simpler/tidier
than the platform-specific FindFunctionSymbol, etc., and moving other
platforms to the plugin-based GetPluginInfo rather than the mimetype-based
InitQuirksModes() is probably the way to go in the future.

Currently AddQuirk() and InitQuirksModes() work (awkwardly) with
QUIRKS_NOT_INITIALIZED because they deal with different plugins on X11, but
InitQuirksModes is already awkward with quirk-free plugins initializing to
QUIRKS_NOT_INITIALIZED.
Comment 22 User image Timothy Nikkel (:tnikkel) 2011-04-25 22:20:04 PDT
That patch fixes it for me!
Comment 23 User image Karl Tomlinson (back Feb 1 :karlt) 2011-04-25 22:30:48 PDT
Created attachment 528263 [details] [diff] [review]
revert to using NP_GetValue 1.0.1

Thanks, Timothy.  Updated patch to 1cc4d287d0b8.
Comment 25 User image Chris Jones [:cjones] inactive; ni?/f?/r? if you need me 2011-04-27 22:09:38 PDT
Comment on attachment 528263 [details] [diff] [review]
revert to using NP_GetValue 1.0.1

>+    // Maemo flash can render plugin with any provided rectangle and not
>+    // require this quirk.

Do you mind fixing the grammar here while you're at it?
Comment 26 User image Matěj Cepl 2011-05-02 15:21:14 PDT
Internesting ... When looking at http://live.twit.tv I see clearly Bitstream (1Mbps), but Bitstream (400 Kbps) is pretty bad.
Comment 27 User image Matěj Cepl 2011-05-05 23:19:48 PDT
(In reply to comment #26)
> Internesting ... When looking at http://live.twit.tv I see clearly Bitstream
> (1Mbps), but Bitstream (400 Kbps) is pretty bad.

Yes, I can confirm that with nspluginwrapper-1.3.2-1.fc15 I can play both of these streams without any problems.

Thank you
Comment 28 User image Karl Tomlinson (back Feb 1 :karlt) 2011-05-08 17:17:39 PDT
(Including grammar touch up:)
http://hg.mozilla.org/mozilla-central/rev/c26ec595c923

Note You need to log in before you can comment on or make changes to this bug.